# Request to withdraw funds

POST https://api.letsdeel.com/rest/v2/payouts/withdrawals
Content-Type: application/json

Request to withdraw some or all of the available funds to a method
 **Token scopes**: `worker:write`

Reference: https://developer.deel.com/api/reference/endpoints/payouts/request-to-withdraw-funds

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /payouts/withdrawals:
    post:
      operationId: request-to-withdraw-funds
      summary: Request to withdraw funds
      description: |-
        Request to withdraw some or all of the available funds to a method
         **Token scopes**: `worker:write`
      tags:
        - subpackage_payouts
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Withdrawal successfully initiated
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Payouts_requestToWithdrawFunds_Response_201
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/RequestToWithdrawFundsRequestInternalServerError
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/PayoutsWithdrawalsPostRequestBodyContentApplicationJsonSchemaData
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    PayoutsWithdrawalsPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        amount:
          type: number
          format: double
          description: Amount to withdraw (must be positive)
        currency:
          type: string
          description: Currency code for the withdrawal amount
        withdrawal_method_id:
          type: string
          format: uuid
          description: Id of the withdrawal method to use
      required:
        - amount
        - currency
        - withdrawal_method_id
      title: PayoutsWithdrawalsPostRequestBodyContentApplicationJsonSchemaData
    PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: ID of the created transaction
        amount:
          type: number
          format: double
          description: Amount of the transaction
        currency:
          type: string
          description: Currency of the transaction
        created_at:
          type: string
          format: date-time
          description: Timestamp of the transaction creation
        updated_at:
          type: string
          format: date-time
          description: Timestamp of the transaction update
      title: PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaData
    Payouts_requestToWithdrawFunds_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaData
      title: Payouts_requestToWithdrawFunds_Response_201
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaErrorsItems:
      type: object
      properties:
        message:
          type: string
          description: Error message
      title: PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaErrorsItems
    RequestToWithdrawFundsRequestInternalServerError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/PayoutsWithdrawalsPostResponsesContentApplicationJsonSchemaErrorsItems
      title: RequestToWithdrawFundsRequestInternalServerError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/payouts/withdrawals"

payload = { "data": {
        "amount": 100,
        "currency": "USD",
        "withdrawal_method_id": "123e4567-e89b-12d3-a456-426614174000"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/payouts/withdrawals';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"amount":100,"currency":"USD","withdrawal_method_id":"123e4567-e89b-12d3-a456-426614174000"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/payouts/withdrawals"

	payload := strings.NewReader("{\n  \"data\": {\n    \"amount\": 100,\n    \"currency\": \"USD\",\n    \"withdrawal_method_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/payouts/withdrawals")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"amount\": 100,\n    \"currency\": \"USD\",\n    \"withdrawal_method_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/payouts/withdrawals")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"amount\": 100,\n    \"currency\": \"USD\",\n    \"withdrawal_method_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/payouts/withdrawals', [
  'body' => '{
  "data": {
    "amount": 100,
    "currency": "USD",
    "withdrawal_method_id": "123e4567-e89b-12d3-a456-426614174000"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/payouts/withdrawals");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"amount\": 100,\n    \"currency\": \"USD\",\n    \"withdrawal_method_id\": \"123e4567-e89b-12d3-a456-426614174000\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "amount": 100,
    "currency": "USD",
    "withdrawal_method_id": "123e4567-e89b-12d3-a456-426614174000"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/payouts/withdrawals")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```